Attribute VB_Name = "modUtils"
Public clrDlg As CommonDialog

Public Function RGBFromLong(l As Long) As OLE_COLOR
  Dim r, g, b As Integer
  r = l And 255
  g = CLng((l - r) / 256) And 255
  b = CLng((l - 256 * g - r) / 65536) And 255
  RGBFromLong = RGB(r, g, b)
End Function

Private Function PickColor(clrDlg As CommonDialog) As Boolean
  On Error GoTo cancelHandler
  With clrDlg
    .Flags = cdlCCFullOpen + cdlCCRGBInit
    .CancelError = True
    .ShowColor
  End With
  PickColor = True
  Exit Function
cancelHandler:
  If Err.Number = cdlCancel Then
    PickColor = False
    Exit Function
  Else
    Resume Next
  End If
End Function

Public Function ChangeColor(ctr As Control, Optional isBack As Boolean = False) As Boolean
  With clrDlg
    .Color = ctr.ForeColor
    If PickColor(clrDlg) Then
      If Not isBack Then
        ChangeColor = IIf(.Color = GetSysColor(COLOR_WINDOWTEXT), False, True)
        ctr.ForeColor = .Color
      Else
        ChangeColor = IIf(.Color = GetSysColor(COLOR_WINDOW), False, True)
        ctr.BackColor = .Color
      End If
      Else
      ChangeColor = False
    End If
  End With
End Function

' ###############################################################

Public Sub Delay(n As Long)
  Dim t As Long
  t = GetTickCount
  Do While t + n < GetTickCount
    DoEvents
  Loop
End Sub

' ###############################################################

Public Function GetAppSetting(sKey As String, Optional sDefault As String = "")
  GetAppSetting = GetSetting(App.EXEName, "General", sKey, sDefault)
End Function

Public Function SaveAppSetting(sKey As String, sValue As String)
  SaveSetting App.EXEName, "General", sKey, sValue
End Function

Public Sub LoadFormPosition(fForm As Form)
  Dim s As String
  '
  s = GetSetting(App.EXEName, "General", fForm.Name & "_state", "-1")
  If Val(s) >= 0 Then
    '
    fForm.Top = Val(GetSetting(App.EXEName, "General", fForm.Name & "_top", fForm.Top & ""))
    fForm.Left = Val(GetSetting(App.EXEName, "General", fForm.Name & "_left", fForm.Left & ""))
    fForm.Width = Val(GetSetting(App.EXEName, "General", fForm.Name & "_width", fForm.Width & ""))
    fForm.Height = Val(GetSetting(App.EXEName, "General", fForm.Name & "_height", fForm.Height & ""))
    '
    fForm.WindowState = Val(s)
    '
  End If
End Sub

Public Sub SaveFormPosition(fForm As Form)
  SaveAppSetting fForm.Name & "_state", fForm.WindowState
  '
  If fForm.WindowState = vbMaximized Then fForm.WindowState = vbNormal
  '
  SaveAppSetting fForm.Name & "_top", fForm.Top & ""
  SaveAppSetting fForm.Name & "_left", fForm.Left & ""
  SaveAppSetting fForm.Name & "_width", fForm.Width & ""
  SaveAppSetting fForm.Name & "_height", fForm.Height & ""
End Sub

Public Function CanPersistFormValue(fForm As Form, i As Integer)
  Dim b As Boolean
  '
  b = False
  If TypeName(fForm.Controls(i)) = "TextBox" Then
    b = True
  End If
  If Not b Then
    If (TypeName(fForm.Controls(i)) = "ComboBox") Then
      If fForm.Controls(i).Style <> vbComboDropdownList Then
        b = True
      End If
    End If
  End If
  '
  CanPersistFormValue = b
End Function

Public Sub LoadFormValues(fForm As Form)
  Dim i As Integer
  For i = 0 To fForm.Controls.Count - 1
    If CanPersistFormValue(fForm, i) Then
      fForm.Controls(i).Text = GetAppSetting(fForm.Controls(i).Name & ".Text")
    End If
  Next i
End Sub

Public Sub SaveFormValues(fForm As Form)
  Dim i As Integer
  For i = 0 To fForm.Controls.Count - 1
    If CanPersistFormValue(fForm, i) Then
      SaveAppSetting fForm.Controls(i).Name & ".Text", fForm.Controls(i).Text
    End If
  Next i
End Sub

Public Sub SaveSet(s1 As String, s2 As String, Optional sCategory As String = "Main")
  If s1 <> "" Then
    SaveSetting "Plus4IDE", sCategory, s1, s2
  End If
End Sub

Public Function GetSet(s1 As String)
  GetSet = GetSetting("Plus4IDE", "Main", s1)
End Function

Public Function GetOptions(s1 As String, Optional sDefault As String = "")
  GetOptions = GetSetting("Plus4IDE", "Options", s1, sDefault)
End Function

Public Function AppPath()
  Dim s As String
  s = App.Path
  If Right$(s, 1) <> "\" Then s = s + "\"
  AppPath = s
End Function

Public Function XTrim$(ByVal s As String)
  Dim s0 As String
  s0 = s
  Do While Left$(s0, 1) = Chr$(9) Or Left$(s0, 1) = Chr$(32)
    s0 = Mid$(s0, 2)
  Loop
  Do While Right$(s0, 1) = Chr$(9) Or Right$(s0, 1) = Chr$(32)
    s0 = Left$(s0, Len(s0) - 1)
  Loop
  XTrim$ = s0
End Function
